## net.sf.saxon.expr.instruct
Class WithParam

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.instruct.Instruction
              net.sf.saxon.expr.instruct.GeneralVariable
                  net.sf.saxon.expr.instruct.WithParam

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, Binding, EvaluableItem, TailCallReturner, SequenceIterable, InstructionInfo, Locator

    public class WithParam

extends GeneralVariable

An instruction derived from a xsl:with-param element in the stylesheet.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.instruct.GeneralVariable
`evaluationMode, referenceCount, slotNumber, variableQName`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, PUSH_SELECTION, staticProperties, WATCH_METHOD`

Constructor Summary
`WithParam()`

Method Summary
`static WithParam[]` `copy(WithParam[] params)` Copy a set of parameters
`static void` `displayExpressions(WithParam[] params, ExpressionPresenter out)` DIsplay the parameter expressions
`ValueRepresentation` `evaluateVariable(XPathContext context)` Evaluate the variable (method exists only to satisfy the interface)
`int` `getInstructionNameCode()` Get the name of this instruction (that is xsl:variable, xsl:param etc) for diagnostics
`int` `getParameterId()` Get the parameter id, which is essentially an alias for the parameter name, unique within a stylesheet
`static void` `getXPathExpressions(WithParam[] params, List list)` Get the XPath expressions used in an array of WithParam parameters (add them to the supplied list)
`boolean` `isTypeChecked()` Ask whether static type checking has been done
`static void` `optimize(ExpressionVisitor visitor, WithParam[] params, ItemType contextItemType)`
`TailCall` `processLeavingTail(XPathContext context)` ProcessLeavingTail: called to do the real work of this instruction.
`static void` `promoteParams(Expression parent, WithParam[] params, PromotionOffer offer)` Promote the expressions in a set of with-param elements.
`static boolean` `replaceXPathExpression(WithParam[] params, Expression original, Expression replacement)` Replace a subexpression
`void` `setParameterId(int id)` Allocate a number which is essentially an alias for the parameter name, unique within a stylesheet
`void` `setTypeChecked(boolean checked)` Say whether this parameter will have been typechecked by the caller to ensure it satisfies the required type, in which case the callee need not do a dynamic type check
`static void` `simplify(WithParam[] params, ExpressionVisitor visitor)`
`static void` `typeCheck(WithParam[] params, ExpressionVisitor visitor, ItemType contextItemType)`

Methods inherited from class net.sf.saxon.expr.instruct.GeneralVariable

`copy, evaluateItem, explain, getCardinality, getEvaluationMode, getItemType, getLocalSlotNumber, getRequiredType, getSelectExpression, getSelectValue, getSlotNumber, getVariableQName, init, isAssignable, isGlobal, isImplicitlyRequiredParam, isRequiredParam, isTunnelParam, iterate, iterateSubExpressions, optimize, promoteInst, replaceSubExpression, setAssignable, setImplicitlyRequiredParam, setReferenceCount, setRequiredParam, setRequiredType, setSelectExpression, setSlotNumber, setTunnel, setVariableQName, simplify, typeCheck`

Methods inherited from class net.sf.saxon.expr.instruct.Instruction
`assembleParams, assembleTunnelParams, computeCardinality, computeSpecialProperties, createsNewNodes, dynamicError, evaluateAsString, getConstructType, getExpressionName, getImplementationMethod, getInstructionName, getIteratorFromProcessMethod, getSourceLocator, isXSLT, process, promote`

Methods inherited from class net.sf.saxon.expr.Expression

`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluatePendingUpdates, explain, getColumnNumber, getColumnNumber, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateEvents, iterateSameFocusSubExpressions, markTailFunctionCalls, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, toString, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### WithParam

    public WithParam()

Method Detail

### setParameterId

    public void setParameterId(int id)

  Allocate a number which is essentially an alias for the parameter name, unique within a stylesheet

  Parameters:
    `id` - the parameter id

### setTypeChecked

    public void setTypeChecked(boolean checked)

  Say whether this parameter will have been typechecked by the caller to ensure it satisfies the required type, in which case the callee need not do a dynamic type check

  Parameters:
    `checked` - true if the caller has done static type checking against the required type

### getParameterId

    public int getParameterId()

  Get the parameter id, which is essentially an alias for the parameter name, unique within a stylesheet

  Returns:
    the parameter id

### getInstructionNameCode

    public int getInstructionNameCode()

  Description copied from class: `GeneralVariable`
  Get the name of this instruction (that is xsl:variable, xsl:param etc) for diagnostics

  Overrides:
    `getInstructionNameCode` in class `GeneralVariable`
  Returns:
    the name of this instruction, as a name pool name code

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Description copied from class: `Instruction`
  ProcessLeavingTail: called to do the real work of this instruction. This method must be implemented in each subclass. The results of the instruction are written to the current Receiver, which can be obtained via the Controller.

  Specified by:
    `processLeavingTail` in interface `TailCallReturner`
  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` - The dynamic context of the transformation, giving access to the current node, the current variables, etc.
  Returns:
    null if the instruction has completed execution; or a TailCall indicating a function call or template call that is delegated to the caller, to be made after the stack has been unwound so as to save stack space.
  Throws:
    `XPathException`

### simplify

    public static void simplify(WithParam[] params,
                                ExpressionVisitor visitor)
                         throws XPathException

  Throws:
    `XPathException`

### typeCheck

    public static void typeCheck(WithParam[] params,
                                 ExpressionVisitor visitor,
                                 ItemType contextItemType)
                          throws XPathException

  Throws:
    `XPathException`

### optimize

    public static void optimize(ExpressionVisitor visitor,
                                WithParam[] params,
                                ItemType contextItemType)
                         throws XPathException

  Throws:
    `XPathException`

### promoteParams

    public static void promoteParams(Expression parent,
                                     WithParam[] params,
                                     PromotionOffer offer)
                              throws XPathException

  Promote the expressions in a set of with-param elements. This is a convenience method for use by containing instructions.

  Throws:
    `XPathException`

### copy

    public static WithParam[] copy(WithParam[] params)

  Copy a set of parameters

  Parameters:
    `params` - the parameters to be copied
  Returns:
    the resulting copy

### getXPathExpressions

    public static void getXPathExpressions(WithParam[] params,
                                           List list)

  Get the XPath expressions used in an array of WithParam parameters (add them to the supplied list)

### displayExpressions

    public static void displayExpressions(WithParam[] params,
                                          ExpressionPresenter out)

  DIsplay the parameter expressions

### replaceXPathExpression

    public static boolean replaceXPathExpression(WithParam[] params,
                                                 Expression original,
                                                 Expression replacement)

  Replace a subexpression

### evaluateVariable

    public ValueRepresentation evaluateVariable(XPathContext context)
                                         throws XPathException

  Evaluate the variable (method exists only to satisfy the interface)

  Parameters:
    `context` - the XPath dynamic evaluation context
  Returns:
    the result of evaluating the variable
  Throws:
    `XPathException`

### isTypeChecked

    public boolean isTypeChecked()

  Ask whether static type checking has been done

  Returns:
    true if the caller has done static type checking against the type required by the callee

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.